package com.alentoma.selectabletext;


import android.text.TextPaint;
import android.text.style.ClickableSpan;
import android.view.View;

import androidx.annotation.NonNull;

import com.facebook.react.bridge.ReactContext;
import com.facebook.react.uimanager.UIManagerHelper;
import com.facebook.react.uimanager.events.EventDispatcher;
import com.facebook.react.views.text.ReactSpan;
import com.facebook.react.views.view.ViewGroupClickEvent;

/*
    This is an exact copy of ReactClickableSpan, since this class was not discoverable from the current package
*/
class CustomReactClickableSpan extends ClickableSpan implements ReactSpan {
    private final int mReactTag;

    CustomReactClickableSpan(int reactTag) {
        this.mReactTag = reactTag;
    }

    public void onClick(@NonNull View view) {
        ReactContext context = (ReactContext) view.getContext();
        EventDispatcher eventDispatcher = UIManagerHelper.getEventDispatcherForReactTag(context, this.mReactTag);
        if (eventDispatcher != null) {
            eventDispatcher.dispatchEvent(new ViewGroupClickEvent(UIManagerHelper.getSurfaceId(context), this.mReactTag));
        }

    }

    public void updateDrawState(@NonNull TextPaint ds) {
    }

    public int getReactTag() {
        return this.mReactTag;
    }
}
