package com.alentoma.selectabletext;

import android.view.ActionMode;
import android.view.ActionMode.Callback;
import android.view.Menu;
import android.view.MenuItem;

import androidx.annotation.NonNull;

import com.facebook.react.bridge.ReadableArray;
import com.facebook.react.common.MapBuilder;
import com.facebook.react.uimanager.annotations.ReactProp;
import com.facebook.react.views.text.ReactTextView;

import java.util.Map;

public class RNSelectableTextManager extends CustomReactTextViewManager {
    public static final String REACT_CLASS = "RNSelectableText";

    @NonNull
    @Override
    public String getName() {
        return REACT_CLASS;
    }

    @ReactProp(name = "highlights")
    public void setHighlights(ReactTextView textView, ReadableArray highlights) {
        // TODO: find a better way to register selection listener
        registerCustomSelectionActionCallbackListener(textView);
    }

    public void registerCustomSelectionActionCallbackListener(final ReactTextView view) {
        view.setCustomSelectionActionModeCallback(new Callback() {
            @Override
            public boolean onPrepareActionMode(ActionMode mode, Menu menu) {
                menu.clear();
                return true;
            }

            @Override
            public boolean onCreateActionMode(ActionMode mode, Menu menu) {
                return true;
            }

            @Override
            public void onDestroyActionMode(ActionMode mode) {
            }

            @Override
            public boolean onActionItemClicked(ActionMode mode, MenuItem item) {
                mode.finish();
                return true;
            }
        });
    }

    @Override
    public Map<String, Object> getExportedCustomDirectEventTypeConstants() {
        MapBuilder.Builder<String, Object> builder = MapBuilder.builder();

        builder.put("topOnTextSelectionChange", MapBuilder.of("registrationName", "onTextSelectionChange"));
        builder.put("topOnHighlightRectsCalculated", MapBuilder.of("registrationName", "onHighlightRectsCalculated"));

        return builder.build();
    }
}
